#!/bin/sh

echo "Converting video files on harddrive ..."

MATCH=$1*.mov
echo "Processing files matching: $MATCH"

# Get working directory
D=`pwd`

# Show files and sizes
cd /video
du -hc $MATCH
cd $D

# pause
echo "Press Enter to continue Ctrl+C to abort:"
read DUMMY

# converter program
MPLAYER="/usr/local/bin/mplayer"

# Process videos
cd /video
for FILENAME in $MATCH; do
 F=$FILENAME
 FHD=${F##HD}
 if [ "$F" == "$FHD" ]; then
  echo "Box-converting $F (DV-PAL .mov to 256x256 DXT3 frames) ... "

  # Source is DV 768x576 
  PARAMS="-nosound -noaspect -sws 9 -vop scale=256:256,crop=576:576:96:0,pp=ha/va/dr -vo glstream:dxt3:file="
  INPUT=$F
  OUTPUT=/video/${INPUT%%.mov}_box.dxt3
 
  $MPLAYER $PARAMS$OUTPUT $INPUT
  echo Converted $INPUT to $OUTPUT ...

  echo "Box-converting $F (DV-PAL .mov to 256x256 LZF-DTX3 frames) ... "

  # Source is DV 768x576 
  PARAMS="-nosound -noaspect -sws 9 -vop scale=256:256,crop=576:576:96:0,pp=ha/va/dr -vo glstream:dxt3:lzf:file="
  INPUT=$F
  OUTPUT=/video/${INPUT%%.mov}_box.dxt3lzf
 
  $MPLAYER $PARAMS$OUTPUT $INPUT
  echo Converted $INPUT to $OUTPUT ...
  
 else
  echo "HD-converting $F (HD 720p .mov to 1280x720 DXT3 frames) ..."
  
  # Source is HD 720p
  PARAMS="-nosound -noaspect -sws 9 -vop scale=1280:720,pp=ha/va/dr -vo glstream:dxt3:file="
  INPUT=$F 
  OUTPUT=/video/${INPUT%%.mov}_hd.dxt3
 
  $MPLAYER $PARAMS$OUTPUT $INPUT
  echo Converted $INPUT to $OUTPUT ...

  echo "HD-converting $F (HD 720p .mov to 512x512 RGBA frames) ..."
  
  # Source is HD 720p
  PARAMS="-nosound -noaspect -sws 9 -vop scale=512:512,pp=ha/va/dr -vo glstream:rgba:file="
  INPUT=$F 
  OUTPUT=/video/${INPUT%%.mov}_hd.rgba512
 
  $MPLAYER $PARAMS$OUTPUT $INPUT
  echo Converted $INPUT to $OUTPUT ...

  echo "HD-converting $F (HD 720p .mov to 1024x512 LZF-RGBA frames) ..."
  
  # Source is HD 720p
  PARAMS="-nosound -noaspect -sws 9 -vop scale=1024:512,pp=ha/va/dr -vo glstream:rgba:lzf:file="
  INPUT=$F 
  OUTPUT=/video/${INPUT%%.mov}_hd.rgba1024lzf
 
  $MPLAYER $PARAMS$OUTPUT $INPUT
  echo Converted $INPUT to $OUTPUT ...
  
 fi
done

# Restore working directory
cd $D
