/*
 * example.c: very simple example of port I/O
 *
 * This code does nothing useful, just a port write, a pause,
 * and a port read. Compile with `gcc -O2 -o example example.c',
 * and run as root with `./example'.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/io.h>

#define BASEPORT0 0x03bc  /* /dev/lp0 */
#define BASEPORT1 0x0378  /* /dev/lp1 */
#define BASEPORT2 0x0278  /* /dev/lp2 */

#define BASEPORT3 0xb400 /* /dev/lpX */

int main()
{
  int i;
  int port = BASEPORT3;

  /* Get access to the ports */
  if (ioperm(port, 3, 1)) {perror("ioperm"); exit(1);}
 
  while (1) {   
   /* Set the data signals (D0-7) of the port to all low (0) */
   outb(0, port);
  
   /* Sleep for a while (100 ms) */
   usleep(100*1000);

   outb(3, port);

   usleep(100*1000);

   /* Read from the status port (BASE+1) and display the result */
   printf("status: %d\n", inb(port + 1)
   );

  }


  /* We don't need the ports anymore */
  if (ioperm(port, 3, 0)) {perror("ioperm"); exit(1);}

  exit(0);
}

/* end of example.c */
